Index: NEMO/releases/r4.0/r4.0.3/INSTALL.rst
===================================================================
--- NEMO/releases/r4.0/r4.0.3/INSTALL.rst	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/INSTALL.rst	(revision 14461)
@@ -110,5 +110,5 @@
    This particular version has its own branch and can be checked out with:
 
-   .. code:: console
+   .. code-block:: console
 
       $ svn co https://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/branchs/xios-2.5
@@ -120,7 +120,7 @@
 -------------------------
 
-.. code:: console
-
-   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/releases/release-4.0-HEAD
+.. code-block:: console
+
+   $ svn co https://forge.ipsl.jussieu.fr/nemo/svn/NEMO/releases/r4.0.3
 
 Description of 1\ :sup:`st` level tree structure
Index: NEMO/releases/r4.0/r4.0.3/doc/latex/NEMO/subfiles/apdx_triads.tex
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/latex/NEMO/subfiles/apdx_triads.tex	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/doc/latex/NEMO/subfiles/apdx_triads.tex	(revision 14461)
@@ -1,13 +1,3 @@
 \documentclass[../main/NEMO_manual]{subfiles}
-
-%% Local cmds
-\newcommand{\rML}[1][i]{\ensuremath{_{\mathrm{ML}\,#1}}}
-\newcommand{\rMLt}[1][i]{\tilde{r}_{\mathrm{ML}\,#1}}
-%% Move to ../../global/new_cmds.tex to avoid error with \listoffigures
-%\newcommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}
-\newcommand{\triadd}[5]{\ensuremath{{}_{#1}^{#2}{\mathbb{#3}}_{#4}^{\,#5}}}
-\newcommand{\triadt}[5]{\ensuremath{{}_{#1}^{#2}{\tilde{\mathbb{#3}}}_{#4}^{\,#5}}}
-\newcommand{\rtriad}[2][]{\ensuremath{\triad[#1]{i}{k}{#2}{i_p}{k_p}}}
-\newcommand{\rtriadt}[1]{\ensuremath{\triadt{i}{k}{#1}{i_p}{k_p}}}
 
 \begin{document}
Index: NEMO/releases/r4.0/r4.0.3/doc/latex/NEMO/subfiles/chap_ZDF.tex
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/latex/NEMO/subfiles/chap_ZDF.tex	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/doc/latex/NEMO/subfiles/chap_ZDF.tex	(revision 14461)
@@ -1,6 +1,3 @@
 \documentclass[../main/NEMO_manual]{subfiles}
-
-%% Custom aliases
-\newcommand{\cf}{\ensuremath{C\kern-0.14em f}}
 
 \begin{document}
Index: NEMO/releases/r4.0/r4.0.3/doc/latex/TOP/subfiles/model_description.tex
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/latex/TOP/subfiles/model_description.tex	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/doc/latex/TOP/subfiles/model_description.tex	(revision 14461)
@@ -1,12 +1,3 @@
 \documentclass[../main/TOP_manual]{subfiles}
-
-\newcommand{\cd}{\mathrm{CO_2}}
-\newcommand{\Ct}{\mathrm{C_T}}
-\newcommand{\pacd}{\mathrm{p^a_{CO_2}}}
-\newcommand{\cq}{\mathrm{^{14}C}}
-\newcommand{\Dcq}{\Delta ^{14}\mathrm{C}}
-\newcommand{\Rq}{\mathrm{^{14}{R}}}
-\newcommand{\CODE}[1]{\textsc{#1}}
-%\newcommand{\CODE}[1]{\textcolor{black}{\textsc{#1}}\xspace}
 
 \begin{document}
Index: NEMO/releases/r4.0/r4.0.3/doc/latex/global/new_cmds.tex
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/latex/global/new_cmds.tex	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/doc/latex/global/new_cmds.tex	(revision 14461)
@@ -58,6 +58,20 @@
 \newcommand{\orcid}[1]{\href{http://orcid.org/#1}{\textcolor{orcidcolor}\aiOrcidSquare}}
 
-%% Workaround for \listoffigures
-\DeclareRobustCommand{\triad}[6][]{\ensuremath{ {}_{#2}^{#3} { \mathbb{#4}_{#1} }_{#5}^{\,#6} }}
+%% Custom aliases
+\newcommand{\cf}{\ensuremath{C\kern-0.14em f}}
+\newcommand{\rML}[1][i]{\ensuremath{_{\mathrm{ML}\,#1}}}
+\newcommand{\rMLt}[1][i]{\tilde{r}_{\mathrm{ML}\,#1}}
+\newcommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}}
+\newcommand{\triadd}[5]{\ensuremath{{}_{#1}^{#2}{\mathbb{#3}}_{#4}^{\,#5}}}
+\newcommand{\triadt}[5]{\ensuremath{{}_{#1}^{#2}{\tilde{\mathbb{#3}}}_{#4}^{\,#5}}}
+\newcommand{\rtriad}[2][]{\ensuremath{\triad[#1]{i}{k}{#2}{i_p}{k_p}}}
+\newcommand{\rtriadt}[1]{\ensuremath{\triadt{i}{k}{#1}{i_p}{k_p}}}
+\newcommand{\cd}{\mathrm{CO_2}}
+\newcommand{\Ct}{\mathrm{C_T}}
+\newcommand{\pacd}{\mathrm{p^a_{CO_2}}}
+\newcommand{\cq}{\mathrm{^{14}C}}
+\newcommand{\Dcq}{\Delta ^{14}\mathrm{C}}
+\newcommand{\Rq}{\mathrm{^{14}{R}}}
+\newcommand{\CODE}[1]{\textsc{#1}}
 
 %% New command for ToC
Index: NEMO/releases/r4.0/r4.0.3/doc/latex/global/styles.tex
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/latex/global/styles.tex	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/doc/latex/global/styles.tex	(revision 14461)
@@ -72,14 +72,3 @@
 }
 
-%% Temporary fix
-\def\set@curr@file#1{%
-  \begingroup
-    \escapechar\m@ne
-    \xdef\@curr@file{\expandafter\string\csname #1\endcsname}%
-  \endgroup
-}
-\def\quote@name#1{"\quote@@name#1\@gobble""}
-\def\quote@@name#1"{#1\quote@@name}
-\def\unquote@name#1{\quote@@name#1\@gobble"}
-
 \makeatother
Index: NEMO/releases/r4.0/r4.0.3/doc/rst/requirements.txt
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/rst/requirements.txt	(revision 14461)
+++ NEMO/releases/r4.0/r4.0.3/doc/rst/requirements.txt	(revision 14461)
@@ -0,0 +1,27 @@
+alabaster==0.7.12
+Babel==2.9.0
+certifi==2020.12.5
+chardet==4.0.0
+docutils==0.16
+idna==2.10
+imagesize==1.2.0
+Jinja2==2.11.3
+latexcodec==2.0.1
+MarkupSafe==1.1.1
+oset==0.1.3
+packaging==20.9
+pybtex==0.24.0
+pybtex-docutils==0.2.2
+Pygments==2.5.2
+pyparsing==2.4.7
+pytz==2021.1
+PyYAML==5.4.1
+requests==2.25.1
+six==1.15.0
+snowballstemmer==2.1.0
+Sphinx==1.8.5
+sphinx-rtd-theme==0.5.1
+sphinxcontrib-bibtex==0.4.2
+sphinxcontrib-websupport==1.1.2
+typing==3.7.4.3
+urllib3==1.26.3
Index: NEMO/releases/r4.0/r4.0.3/doc/rst/source/conf.py
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/rst/source/conf.py	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/doc/rst/source/conf.py	(revision 14461)
@@ -248,5 +248,5 @@
 import datetime
 year = datetime.date.today().year
-copyright = '2008-' + str( year ) + ', NEMO Consortium'
+copyright = '2008-2020, NEMO Consortium'
 
 # Link aliases
Index: NEMO/releases/r4.0/r4.0.3/doc/rst/source/guide.rst
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/rst/source/guide.rst	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/doc/rst/source/guide.rst	(revision 14461)
@@ -66,4 +66,5 @@
 
 :Release:  |release|
+:Date:     Jul. 2020
 
 .. only:: draft
@@ -71,5 +72,4 @@
    .. Only on draft
 
-   :*Date*:     |today|
    :*SVN rev*:  |revision|
 
Index: NEMO/releases/r4.0/r4.0.3/src/OCE/ASM/README.rst
===================================================================
--- NEMO/releases/r4.0/r4.0.3/src/OCE/ASM/README.rst	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/src/OCE/ASM/README.rst	(revision 14461)
@@ -1,1 +1,1 @@
-link ../../../doc/rst/source/data_assimilation.rst
+link ../../../doc/rst/source/da.rst
Index: NEMO/releases/r4.0/r4.0.3/src/OCE/OBS/README.rst
===================================================================
--- NEMO/releases/r4.0/r4.0.3/src/OCE/OBS/README.rst	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/src/OCE/OBS/README.rst	(revision 14461)
@@ -1,1 +1,1 @@
-link ../../../doc/rst/source/data_assimilation.rst
+link ../../../doc/rst/source/da.rst
Index: NEMO/releases/r4.0/r4.0.3/src/OCE/SBC/README.rst
===================================================================
--- NEMO/releases/r4.0/r4.0.3/src/OCE/SBC/README.rst	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/src/OCE/SBC/README.rst	(revision 14461)
@@ -1,1 +1,1 @@
-link ../../../doc/rst/source/coupling.rst
+link ../../../doc/rst/source/cplg.rst
Index: NEMO/releases/r4.0/r4.0.3/src/SAS/README.rst
===================================================================
--- NEMO/releases/r4.0/r4.0.3/src/SAS/README.rst	(revision 13358)
+++ NEMO/releases/r4.0/r4.0.3/src/SAS/README.rst	(revision 14461)
@@ -1,1 +1,1 @@
-link ../../doc/rst/source/coupling.rst
+link ../../doc/rst/source/cplg.rst