Index: NEMO/releases/r4.0/r4.0.3/CHANGES
===================================================================
--- NEMO/releases/r4.0/r4.0.3/CHANGES	(revision 14490)
+++ NEMO/releases/r4.0/r4.0.3/CHANGES	(revision 14490)
@@ -0,0 +1,502 @@
+#######
+Commits
+#######
+
+------------------------------------------------------------------------
+r13350 | smueller | 2020-07-28 14:28:29 +0200 (mar., 28 juil. 2020) | 2 lines
+
+Remedy for the bugs reported in ticket #2492
+
+------------------------------------------------------------------------
+r13348 | acc | 2020-07-27 18:55:57 +0200 (lun., 27 juil. 2020) | 1 line
+
+Branch r4.0-HEAD. Fix simple typo in sbc_blk_init. #2504
+------------------------------------------------------------------------
+r13346 | clem | 2020-07-27 14:52:36 +0200 (lun., 27 juil. 2020) | 1 line
+
+change namelist parameter ln_rhg_chkcvg into nn_rhg_chkcvg to ensure more flexibility
+------------------------------------------------------------------------
+r13344 | clem | 2020-07-27 11:59:42 +0200 (lun., 27 juil. 2020) | 1 line
+
+change spitz12 namelist ^Cnsequently to previous commit
+------------------------------------------------------------------------
+r13343 | clem | 2020-07-27 11:54:24 +0200 (lun., 27 juil. 2020) | 1 line
+
+change namelist parameters (ice and ocean) for best results
+------------------------------------------------------------------------
+r13342 | cetlod | 2020-07-27 11:32:05 +0200 (lun., 27 juil. 2020) | 1 line
+
+r4.0-HEAD : bugfix on PISCES temporal scheme, see ticket #2501
+------------------------------------------------------------------------
+r13340 | clem | 2020-07-27 10:56:04 +0200 (lun., 27 juil. 2020) | 1 line
+
+move bn2 into the right grid
+------------------------------------------------------------------------
+r13331 | cetlod | 2020-07-22 16:00:04 +0200 (mer., 22 juil. 2020) | 1 line
+
+r4.0-HEAD : bugfix in the heat content trend when activating bio-model light penetration, see ticket #2499
+------------------------------------------------------------------------
+r13323 | smueller | 2020-07-17 19:08:12 +0200 (ven., 17 juil. 2020) | 2 lines
+
+Repair of the tracer.stat time-series computation (ticket #2497)
+
+------------------------------------------------------------------------
+r13310 | clem | 2020-07-16 11:13:15 +0200 (jeu., 16 juil. 2020) | 1 line
+
+zdftke: orca1 crashes after 6 months unless implicit drags is used or the input of energy below sea-ice is increased. We chose here to remove the dependency of ice fraction in the surface condition on tke (back to old formulation). The rest of the changes are just there to prevent roundoff errors.
+------------------------------------------------------------------------
+r13297 | andmirek | 2020-07-13 10:01:58 +0200 (lun., 13 juil. 2020) | 2 lines
+
+Ticket #2460 into 4.0-HEAD
+
+------------------------------------------------------------------------
+r13284 | smasson | 2020-07-09 17:12:23 +0200 (jeu., 09 juil. 2020) | 1 line
+
+4.0-HEAD: merge 4.0-HEAD_r12713_clem_dan_fixcpl into 4.0-HEAD
+------------------------------------------------------------------------
+r13280 | smueller | 2020-07-09 13:53:42 +0200 (jeu., 09 juil. 2020) | 4 lines
+
+Remedy for the defect described in ticket #2376
+
+This modification comprises the merging of changesets [12591] and [12602] made in branch ^/NEMO/branches/2020/ticket2377 as a remedy for the corresponding defect in the trunk version of NEMO (see ticket #2377).
+
+------------------------------------------------------------------------
+r13278 | clem | 2020-07-09 12:06:49 +0200 (jeu., 09 juil. 2020) | 1 line
+
+finish changing all the comments in the namelists (from ln_OFF to ln_rdg_OFF)
+------------------------------------------------------------------------
+r13274 | clem | 2020-07-08 18:42:28 +0200 (mer., 08 juil. 2020) | 1 line
+
+forgotten changes in namelist_cfg
+------------------------------------------------------------------------
+r13272 | clem | 2020-07-08 17:00:01 +0200 (mer., 08 juil. 2020) | 1 line
+
+update the doc namelists
+------------------------------------------------------------------------
+r13271 | clem | 2020-07-08 16:53:09 +0200 (mer., 08 juil. 2020) | 1 line
+
+counterpart of ticket #2237 for sea-ice
+------------------------------------------------------------------------
+r13270 | clem | 2020-07-08 16:41:20 +0200 (mer., 08 juil. 2020) | 1 line
+
+should solve ticket #2237
+------------------------------------------------------------------------
+r13268 | clem | 2020-07-08 16:27:49 +0200 (mer., 08 juil. 2020) | 1 line
+
+should solve ticket #2435
+------------------------------------------------------------------------
+r13263 | ayoung | 2020-07-08 09:55:54 +0200 (mer., 08 juil. 2020) | 1 line
+
+Merging changes for ticket #2407.  Patch for iceberg melting stability.  Fully SETTE tested: this merge introduces a change to the results in ORCA2_ICE_PISCES.
+------------------------------------------------------------------------
+r13260 | ayoung | 2020-07-07 14:35:05 +0200 (mar., 07 juil. 2020) | 1 line
+
+Merging changes from ticket #2447.  Additional namelist checks to prevent use of unallocated wave coupling variables.
+------------------------------------------------------------------------
+r13259 | ayoung | 2020-07-07 14:22:34 +0200 (mar., 07 juil. 2020) | 1 line
+
+Merging change from ticket #2445 (introduction of minimum value for surface roughness when nn_z0_met = 3).
+------------------------------------------------------------------------
+r13255 | acc | 2020-07-06 17:41:29 +0200 (lun., 06 juil. 2020) | 1 line
+
+r4.0-HEAD minor changes to satisfy namelist integrity checks. See #2486 and wiki:Developers/NamelistChecker for details. Fully SETTE tested
+------------------------------------------------------------------------
+r13137 | smasson | 2020-06-22 08:29:57 +0200 (lun., 22 juin 2020) | 1 line
+
+r4.0-HEAD: fix maxval values on land subdomains for stpctl, see #2456
+------------------------------------------------------------------------
+r13116 | smasson | 2020-06-16 21:15:19 +0200 (mar., 16 juin 2020) | 1 line
+
+r4.0-HEAD: fix potential deadlock, see #2456
+------------------------------------------------------------------------
+r13101 | rblod | 2020-06-12 13:10:44 +0200 (ven., 12 juin 2020) | 1 line
+
+ticket #2471 : not need for initialisation of hdiv in istate.F90
+------------------------------------------------------------------------
+r13095 | jamesharle | 2020-06-11 14:08:55 +0200 (jeu., 11 juin 2020) | 2 lines
+
+Update indexing in hpg_prj (see ticket #2474) 
+
+------------------------------------------------------------------------
+r13093 | gsamson | 2020-06-10 17:35:50 +0200 (mer., 10 juin 2020) | 1 line
+
+r4.0-HEAD: remove 'lk_diahth' from step_c1d.F90 (not used anymore and already done in trunk)
+------------------------------------------------------------------------
+r13087 | davestorkey | 2020-06-10 12:16:00 +0200 (mer., 10 juin 2020) | 2 lines
+
+r4.0-HEAD : Remove zrhop from dia_ar5. (Ticket #2425).
+
+------------------------------------------------------------------------
+r13085 | davestorkey | 2020-06-10 10:59:29 +0200 (mer., 10 juin 2020) | 2 lines
+
+r4.0-HEAD : fix for ticket #2425.
+
+------------------------------------------------------------------------
+r13067 | smasson | 2020-06-09 10:12:15 +0200 (mar., 09 juin 2020) | 1 line
+
+r4.0-HEAD: fix trdtra when used with traadv_ubs, see #2277
+------------------------------------------------------------------------
+r13066 | smasson | 2020-06-09 09:16:47 +0200 (mar., 09 juin 2020) | 1 line
+
+r4.0-HEAD: sbccpl bugfix when sending 'oce and ice' without ice categories, see #2434
+------------------------------------------------------------------------
+r13061 | smasson | 2020-06-08 15:20:11 +0200 (lun., 08 juin 2020) | 1 line
+
+r4.0-HEAD: fix max number of digits for the cpu number in filename, see #2424
+------------------------------------------------------------------------
+r13029 | cetlod | 2020-06-03 17:04:16 +0200 (mer., 03 juin 2020) | 1 line
+
+r4.0-HEAD : bugfix on PISCES 3D tracers trends
+------------------------------------------------------------------------
+r13013 | smasson | 2020-06-03 10:33:06 +0200 (mer., 03 juin 2020) | 1 line
+
+r4.0-HEAD: make sure error messages are visible, see #2456
+------------------------------------------------------------------------
+r13010 | smasson | 2020-06-03 08:47:01 +0200 (mer., 03 juin 2020) | 1 line
+
+r4.0-HEAD: bugfix, introduced in [12859], when jpnij = 1, see #2478
+------------------------------------------------------------------------
+r12926 | smasson | 2020-05-14 16:10:40 +0200 (jeu., 14 mai 2020) | 1 line
+
+r4.0-HEAD: avoid pollution of atm-ice stress at coastal points, see #2465
+------------------------------------------------------------------------
+r12910 | smasson | 2020-05-12 10:21:19 +0200 (mar., 12 mai 2020) | 1 line
+
+r4.0-HEAD: bugfix potential out-of-bounds in bdydta/bdytides, see #2461
+------------------------------------------------------------------------
+r12901 | laurent | 2020-05-11 15:26:36 +0200 (lun., 11 mai 2020) | 1 line
+
+Fixed nasty tiny bug: constant "rctv0" for virtual air temperature!
+------------------------------------------------------------------------
+r12859 | smasson | 2020-05-03 11:33:32 +0200 (dim., 03 mai 2020) | 1 line
+
+r4-HEAD: stpctl bugfix, see #2456
+------------------------------------------------------------------------
+r12857 | jchanut | 2020-05-02 18:06:55 +0200 (sam., 02 mai 2020) | 2 lines
+
+Correct swapped conditionnal statement in corners (hence undetected without corners) introduced in previous commit, #2440
+
+------------------------------------------------------------------------
+r12850 | cetlod | 2020-05-01 18:21:38 +0200 (ven., 01 mai 2020) | 1 line
+
+r4.0-HEAD : minor bug correction
+------------------------------------------------------------------------
+r12841 | cetlod | 2020-05-01 12:52:40 +0200 (ven., 01 mai 2020) | 1 line
+
+r4.0-HEAD : bugfix on BDY & TOP, see ticket #2389
+------------------------------------------------------------------------
+r12837 | cetlod | 2020-05-01 10:37:37 +0200 (ven., 01 mai 2020) | 1 line
+
+r4.0-HEAD : Bugfixes PISCES model, see ticket #2453, #2454, #2455
+------------------------------------------------------------------------
+r12792 | smasson | 2020-04-22 12:39:09 +0200 (mer., 22 avril 2020) | 1 line
+
+r4.0-HEAD: fixe minor bug in dynvor, see #2446
+------------------------------------------------------------------------
+r12791 | smasson | 2020-04-21 22:41:25 +0200 (mar., 21 avril 2020) | 1 line
+
+r4.0-HEAD: fix coastal boundary conditions in dyn_ldf_blp, see #2449
+------------------------------------------------------------------------
+r12737 | jchanut | 2020-04-10 19:55:11 +0200 (ven., 10 avril 2020) | 2 lines
+
+Fixes AGRIF reproductibility with land processors removal, i.e. #2240. Trunk is not concerned by this problem since nbondi/nbondj variables are not used anymore.
+
+------------------------------------------------------------------------
+r12735 | jchanut | 2020-04-10 16:10:16 +0200 (ven., 10 avril 2020) | 2 lines
+
+Mask initial ice fields if read from file, #2437
+
+------------------------------------------------------------------------
+r12703 | mathiot | 2020-04-07 11:18:07 +0200 (mar., 07 avril 2020) | 1 line
+
+ticket #2406: too long line (> 132 cols)
+------------------------------------------------------------------------
+r12697 | mathiot | 2020-04-06 20:14:06 +0200 (lun., 06 avril 2020) | 1 line
+
+ticket #2406: fix ticket #2406 for r4.0-HEAD
+------------------------------------------------------------------------
+r12673 | mathiot | 2020-04-03 17:50:35 +0200 (ven., 03 avril 2020) | 1 line
+
+ticket #2405: change external path for tools from ^/utils/tools@12273 to ^/utils/tools_r4.0-HEAD@12672
+------------------------------------------------------------------------
+r12651 | smasson | 2020-04-03 09:51:14 +0200 (ven., 03 avril 2020) | 1 line
+
+r4.0-HEAD: nstop>0 on a child grid is ok see #2433
+------------------------------------------------------------------------
+r12640 | smasson | 2020-04-01 14:27:05 +0200 (mer., 01 avril 2020) | 1 line
+
+r4.0-HEAD: numnul with Agrif, see #2378
+------------------------------------------------------------------------
+r12639 | smasson | 2020-04-01 13:06:26 +0200 (mer., 01 avril 2020) | 1 line
+
+r4.0-HEAD: avoid to use unassociated pointers in bdydta, see #2429
+------------------------------------------------------------------------
+r12631 | jchanut | 2020-03-31 10:55:26 +0200 (mar., 31 mars 2020) | 2 lines
+
+Solve #2400 and replace at the same time useless area array by e1e2t
+
+------------------------------------------------------------------------
+r12598 | smasson | 2020-03-25 10:02:31 +0100 (mer., 25 mars 2020) | 1 line
+
+r4.0-HEAD: ice_agrif bugfix, see #2422
+------------------------------------------------------------------------
+r12578 | acc | 2020-03-20 17:28:31 +0100 (ven., 20 mars 2020) | 38 lines
+
+A rearrangement and renaming of parts of the releases directory. These
+changes are to reflect the intention, going forward, to maintain invariant
+tagged releases. In future point releases such as 4.0.2 (and later) will
+remain invariant once tagged. For each main release (in this case 4.0), 
+associated point releases (4.0.2, 4.0.3 etc.) will be located in a
+subdirectory (i.e. r4.0/). Each main release subdirectory will contain an
+evolving bug-fix branch (r4.0-HEAD) on which subsequent bug-fixes may be
+committed and from which future point releases can be made.
+
+These restrictions are introduced too late for release-4.0.1 and earlier
+releases so these are left at the top level. Thus the arrangement of the
+releases directory goes from:
+
+releases --+-- basic_stats.sh
+           |__ CMIP5_IPSL
+           |__ release-3.4
+           |__ release-3.6
+           |__ release-4.0
+           |__ release-4.0.1
+           |__ release-4.0-HEAD
+           |__ release-4.0.2
+
+to:
+
+releases --+-- basic_stats.sh
+           |__ CMIP5_IPSL
+           |__ release-3.4
+           |__ release-3.6
+           |__ release-4.0
+           |__ release-4.0.1
+           |__ r4.0 --+
+                      |__ r4.0-HEAD
+                      |__ r4.0.2
+
+where the last two directory names have been shortened from release- to r.
+Future main releases will involve creating the subdirectory and HEAD branch 
+with an immediate .0 tag branch.
+
+------------------------------------------------------------------------
+
+#######
+Changes
+#######
+
+M       cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg
+M       cfgs/AGRIF_DEMO/EXPREF/namelist_cfg
+M       cfgs/AMM12/EXPREF/namelist_cfg
+M       cfgs/C1D_PAPA/EXPREF/namelist_cfg
+M       cfgs/GYRE_BFM/EXPREF/namelist_cfg
+M       cfgs/GYRE_PISCES/EXPREF/namelist_cfg
+M       cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg
+M       cfgs/ORCA2_OFF_PISCES/EXPREF/namelist_cfg
+M       cfgs/ORCA2_OFF_TRC/EXPREF/namelist_cfg
+M       cfgs/ORCA2_SAS_ICE/EXPREF/namelist_cfg
+M       cfgs/SHARED/field_def_nemo-ice.xml
+M       cfgs/SHARED/field_def_nemo-oce.xml
+M       cfgs/SHARED/namelist_ice_ref
+M       cfgs/SHARED/namelist_pisces_ref
+M       cfgs/SHARED/namelist_ref
+M       cfgs/SHARED/namelist_top_ref
+M       cfgs/SPITZ12/EXPREF/namelist_cfg
+M       cfgs/SPITZ12/EXPREF/namelist_ice_cfg
+M       CHANGES
+M       doc/latex/global/document.tex
+M       doc/latex/global/frontpage.tex
+M       doc/latex/global/latexmk.pl
+M       doc/latex/global/new_cmds.tex
+M       doc/latex/global/packages.tex
+M       doc/latex/global/styles.tex
+M       doc/latex/NEMO/subfiles/apdx_triads.tex
+M       doc/latex/NEMO/subfiles/chap_ZDF.tex
+M       doc/latex/TOP/subfiles/model_description.tex
+M       doc/manual_build.sh
+M       doc/namelists/nambdy_dta
+M       doc/namelists/namdia
+M       doc/namelists/namdrg
+M       doc/namelists/namdrg_bot
+M       doc/namelists/namdrg_top
+M       doc/namelists/namdyn
+M       doc/namelists/namdyn_rhg
+M       doc/namelists/namini
+M       doc/namelists/namsbc_blk
+M       doc/namelists/namsbc_cpl
+M       doc/namelists/namthd
+M       doc/namelists/namthd_pnd
+M       doc/namelists/namthd_zdf
+M       doc/namelists/namzdf_gls
+M       doc/namelists/namzdf_tke
+M       doc/rst/requirements.txt
+M       doc/rst/source/conf.py
+M       doc/rst/source/guide.rst
+M       doc/tools/check_pkg.py
+M       doc/tools/shr_func.sh
+M       INSTALL.rst
+M       src/ICE/ice1d.F90
+M       src/ICE/icealb.F90
+M       src/ICE/icecor.F90
+M       src/ICE/icectl.F90
+M       src/ICE/icedyn_adv.F90
+M       src/ICE/icedyn_adv_pra.F90
+M       src/ICE/icedyn_adv_umx.F90
+M       src/ICE/icedyn.F90
+M       src/ICE/icedyn_rdgrft.F90
+M       src/ICE/icedyn_rhg_evp.F90
+M       src/ICE/icedyn_rhg.F90
+M       src/ICE/ice.F90
+M       src/ICE/iceistate.F90
+M       src/ICE/iceitd.F90
+M       src/ICE/icerst.F90
+M       src/ICE/icesbc.F90
+M       src/ICE/icestp.F90
+M       src/ICE/icethd_dh.F90
+M       src/ICE/icethd_ent.F90
+M       src/ICE/icethd.F90
+M       src/ICE/icethd_pnd.F90
+M       src/ICE/icethd_sal.F90
+M       src/ICE/icethd_zdf_bl99.F90
+M       src/ICE/icethd_zdf.F90
+M       src/ICE/iceupdate.F90
+M       src/ICE/icevar.F90
+M       src/ICE/icewri.F90
+M       src/NST/agrif_oce_interp.F90
+M       src/NST/agrif_oce_sponge.F90
+M       src/NST/agrif_top_interp.F90
+M       src/OCE/ASM/README.rst
+M       src/OCE/BDY/bdydta.F90
+M       src/OCE/BDY/bdyice.F90
+M       src/OCE/BDY/bdy_oce.F90
+M       src/OCE/BDY/bdytides.F90
+M       src/OCE/C1D/step_c1d.F90
+M       src/OCE/DIA/diaar5.F90
+M       src/OCE/DIA/diaharm.F90
+M       src/OCE/DIA/diawri.F90
+M       src/OCE/DOM/domain.F90
+M       src/OCE/DOM/dommsk.F90
+M       src/OCE/DOM/dom_oce.F90
+M       src/OCE/DOM/istate.F90
+M       src/OCE/DYN/divhor.F90
+M       src/OCE/DYN/dynhpg.F90
+M       src/OCE/DYN/dynldf_lap_blp.F90
+M       src/OCE/DYN/dynnxt.F90
+M       src/OCE/DYN/dynspg_ts.F90
+M       src/OCE/DYN/dynvor.F90
+M       src/OCE/DYN/dynzdf.F90
+M       src/OCE/DYN/sshwzv.F90
+M       src/OCE/ICB/icbdyn.F90
+M       src/OCE/ICB/icbini.F90
+M       src/OCE/ICB/icb_oce.F90
+M       src/OCE/ICB/icbrst.F90
+M       src/OCE/ICB/icbthm.F90
+M       src/OCE/ICB/icbtrj.F90
+M       src/OCE/ICB/icbutl.F90
+M       src/OCE/IOM/in_out_manager.F90
+M       src/OCE/IOM/iom_def.F90
+M       src/OCE/IOM/iom.F90
+M       src/OCE/IOM/iom_nf90.F90
+M       src/OCE/LBC/lbclnk.F90
+M       src/OCE/LBC/lbc_lnk_multi_generic.h90
+M       src/OCE/LBC/lib_mpp.F90
+M       src/OCE/LBC/mppini.F90
+M       src/OCE/LBC/mpp_loc_generic.h90
+M       src/OCE/nemogcm.F90
+M       src/OCE/OBS/README.rst
+M       src/OCE/SBC/cpl_oasis3.F90
+M       src/OCE/SBC/README.rst
+M       src/OCE/SBC/sbcblk_algo_ncar.F90
+M       src/OCE/SBC/sbcblk.F90
+M       src/OCE/SBC/sbccpl.F90
+M       src/OCE/SBC/sbcfwb.F90
+M       src/OCE/SBC/sbc_ice.F90
+M       src/OCE/SBC/sbcmod.F90
+M       src/OCE/SBC/sbc_oce.F90
+M       src/OCE/SBC/sbcrnf.F90
+M       src/OCE/SBC/sbcwave.F90
+M       src/OCE/step.F90
+M       src/OCE/STO/stopar.F90
+M       src/OCE/stpctl.F90
+M       src/OCE/TRA/traqsr.F90
+M       src/OCE/TRD/trdtra.F90
+M       src/OCE/ZDF/zdfdrg.F90
+M       src/OCE/ZDF/zdfgls.F90
+M       src/OCE/ZDF/zdfosm.F90
+M       src/OCE/ZDF/zdfphy.F90
+M       src/OCE/ZDF/zdftke.F90
+M       src/OFF/nemogcm.F90
+M       src/SAO/nemogcm.F90
+M       src/SAS/nemogcm.F90
+M       src/SAS/README.rst
+M       src/SAS/step.F90
+M       src/SAS/stpctl.F90
+M       src/TOP/MY_TRC/trcsms_my_trc.F90
+M       src/TOP/oce_trc.F90
+M       src/TOP/PISCES/P4Z/p4zfechem.F90
+M       src/TOP/PISCES/P4Z/p4zmeso.F90
+M       src/TOP/PISCES/P4Z/p4zmicro.F90
+M       src/TOP/PISCES/P4Z/p4zopt.F90
+M       src/TOP/PISCES/P4Z/p4zsbc.F90
+M       src/TOP/PISCES/P4Z/p4zsms.F90
+M       src/TOP/PISCES/SED/sedchem.F90
+M       src/TOP/PISCES/SED/sedinorg.F90
+M       src/TOP/trcbc.F90
+M       src/TOP/trcini.F90
+M       src/TOP/trcstp.F90
+M       src/TOP/TRP/trctrp.F90
+M       tests/BENCH/EXPREF/namelist_cfg_orca025_like
+M       tests/BENCH/EXPREF/namelist_cfg_orca12_like
+M       tests/BENCH/EXPREF/namelist_cfg_orca1_like
+M       tests/BENCH/MY_SRC/usrdef_nam.F90
+M       tests/CANAL/EXPREF/field_def_nemo-oce.xml
+M       tests/CANAL/EXPREF/file_def_nemo-oce.xml
+M       tests/CANAL/EXPREF/namelist_cfg
+M       tests/CANAL/MY_SRC/diawri.F90
+M       tests/CANAL/MY_SRC/stpctl.F90
+M       tests/CANAL/MY_SRC/usrdef_istate.F90
+M       tests/CANAL/MY_SRC/usrdef_nam.F90
+M       tests/CANAL/MY_SRC/usrdef_sbc.F90
+M       tests/CANAL/MY_SRC/usrdef_zgr.F90
+M       tests/ICE_ADV1D/EXPREF/namelist_cfg
+M       tests/ICE_ADV1D/EXPREF/namelist_cfg_120pts
+M       tests/ICE_ADV1D/EXPREF/namelist_cfg_240pts
+M       tests/ICE_ADV1D/EXPREF/namelist_cfg_60pts
+M       tests/ICE_ADV1D/EXPREF/namelist_ice_cfg
+M       tests/ICE_ADV1D/EXPREF/namelist_ice_cfg_120pts
+M       tests/ICE_ADV1D/EXPREF/namelist_ice_cfg_240pts
+M       tests/ICE_ADV1D/EXPREF/namelist_ice_cfg_60pts
+M       tests/ICE_ADV1D/MY_SRC/usrdef_sbc.F90
+M       tests/ICE_ADV2D/EXPREF/namelist_cfg
+M       tests/ICE_ADV2D/EXPREF/namelist_ice_cfg
+M       tests/ICE_ADV2D/MY_SRC/usrdef_sbc.F90
+M       tests/ICE_AGRIF/EXPREF/1_namelist_cfg
+M       tests/ICE_AGRIF/EXPREF/namelist_cfg
+M       tests/ICE_AGRIF/EXPREF/namelist_ice_cfg
+M       tests/ICE_AGRIF/MY_SRC/usrdef_nam.F90
+M       tests/ICE_AGRIF/MY_SRC/usrdef_sbc.F90
+M       tests/ICE_AGRIF/MY_SRC/usrdef_zgr.F90
+M       tests/ISOMIP/EXPREF/namelist_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_cen2_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_vect_een_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_vect_eenH_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_vect_ene_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_vect_ens_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT4_flux_cen2_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT4_flux_ubs_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT4_vect_een_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT4_vect_eenH_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT4_vect_ene_cfg
+M       tests/LOCK_EXCHANGE/EXPREF/namelist_FCT4_vect_ens_cfg
+M       tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_cen-ahm1000_cfg
+M       tests/OVERFLOW/EXPREF/namelist_sco_FCT2_flux_ubs_cfg
+M       tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_cen-ahm1000_cfg
+M       tests/OVERFLOW/EXPREF/namelist_sco_FCT4_flux_ubs_cfg
+M       tests/OVERFLOW/EXPREF/namelist_zps_FCT2_flux_ubs_cfg
+M       tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg
+M       tests/OVERFLOW/EXPREF/namelist_zps_FCT4_vect_een_cfg
+M       tests/VORTEX/EXPREF/1_namelist_cfg
+M       tests/VORTEX/EXPREF/namelist_cfg
+M       tests/WAD/EXPREF/namelist_cfg
Index: NEMO/releases/r4.0/r4.0.3/doc/latex/global/packages.tex
===================================================================
--- NEMO/releases/r4.0/r4.0.3/doc/latex/global/packages.tex	(revision 14489)
+++ NEMO/releases/r4.0/r4.0.3/doc/latex/global/packages.tex	(revision 14490)
@@ -18,5 +18,5 @@
 %% Issue with fontawesome pkg: path to FontAwesome.otf has to be hard-coded
 \defaultfontfeatures{
-    Path = /usr/local/texlive/2019/texmf-dist/fonts/opentype/public/fontawesome/
+    Path = /home/ubuntu/.local/texlive/2020/texmf-dist/fonts/opentype/public/fontawesome/
 }
 \usepackage{academicons, fontawesome, newtxtext}